require "behaviours/wander"
require "behaviours/follow"
require "behaviours/faceentity"
require "behaviours/chaseandattack"
require "behaviours/runaway"
require "behaviours/doaction"
--require "behaviours/choptree"
require "behaviours/findlight"
require "behaviours/panic"
require "behaviours/chattynode"
require "behaviours/leash"

local darkclonebrain = Class(Brain, function(self, inst)
    Brain._ctor(self, inst)
end)


local MIN_FOLLOW = 13
local MAX_FOLLOW = 17
local MED_FOLLOW = 15
local MAX_WANDER_DIST = 15

local MAX_CHASE_TIME = 7
local MAX_CHASE_DIST=15

local RUN_AWAY_DIST=4
local STOP_RUN_AWAY_DIST=8

local function GetFaceTargetFn(inst)
    return inst.components.follower.leader
end

local function KeepFaceTargetFn(inst, target)
    return inst.components.follower.leader == target
end




local function speedup(inst,down)
if down then
    inst.components.locomotor.runspeed = math.random(2,3)
    inst.components.locomotor.walkspeed = math.random(2,3)
else
    inst.components.locomotor.runspeed = math.random(4.5,6)
    inst.components.locomotor.walkspeed = math.random(4.5,6)
end
return true
end

function darkclonebrain:OnStart()

    local root = PriorityNode(
    {
            ChattyNode(self.inst, STRINGS.CLONE_TALK_ATTACK,
                WhileNode( function() return speedup(self.inst,nil) and self.inst.components.combat.target == nil or not self.inst.components.combat:InCooldown() end, "AttackMomentarily",
                    ChaseAndAttack(self.inst, MAX_CHASE_TIME, MAX_CHASE_DIST) )),
            ChattyNode(self.inst, STRINGS.CLONE_TALK_ATTACK,
                WhileNode( function() return speedup(self.inst,true) and self.inst.components.combat.target and self.inst.components.combat:InCooldown() end, "Dodge",
                    RunAway(self.inst, function() return self.inst.components.combat.target end, RUN_AWAY_DIST, STOP_RUN_AWAY_DIST)	)),

		Follow(self.inst, function() return self.inst.components.follower.leader end, MIN_FOLLOW, MED_FOLLOW, MAX_FOLLOW, true),
		--FaceEntity(self.inst, GetFaceTargetFn, KeepFaceTargetFn),
        Wander(self.inst, function() return Point(GetPlayer().Transform:GetWorldPosition()) end , MAX_WANDER_DIST) 
    }, .5)
        
    self.bt = BT(self.inst, root)
         
end


return darkclonebrain