require "class"
local Badge = require "widgets/badge"
local easing = require "easing"
local brain = require "brains/darkclonebrain"
local function OnSane(inst)
	print ("SANE!")
end

local function OnInsane(inst)
---	inst.SoundEmitter:PlaySound("dontstarve/sanity/gonecrazy_stinger")
end

local assets =
{
	Asset("ANIM", "anim/player_basic.zip"),
        Asset("ANIM", "anim/player_idles_shiver.zip"),
        Asset("ANIM", "anim/player_actions.zip"),
        Asset("ANIM", "anim/player_actions_axe.zip"),
        Asset("ANIM", "anim/player_actions_pickaxe.zip"),
        Asset("ANIM", "anim/player_actions_shovel.zip"),
        Asset("ANIM", "anim/player_actions_blowdart.zip"),
        Asset("ANIM", "anim/player_actions_eat.zip"),
        Asset("ANIM", "anim/player_actions_item.zip"),
        Asset("ANIM", "anim/player_cave_enter.zip"),
        Asset("ANIM", "anim/player_actions_uniqueitem.zip"),
        Asset("ANIM", "anim/player_actions_bugnet.zip"),
        Asset("ANIM", "anim/player_actions_fishing.zip"),
        Asset("ANIM", "anim/player_actions_boomerang.zip"),
        Asset("ANIM", "anim/player_bush_hat.zip"),
        Asset("ANIM", "anim/player_attacks.zip"),
        Asset("ANIM", "anim/player_idles.zip"),
        Asset("ANIM", "anim/player_rebirth.zip"),
        Asset("ANIM", "anim/player_jump.zip"),
        Asset("ANIM", "anim/player_amulet_resurrect.zip"),
		Asset("ANIM", "anim/player_teleport.zip"),
        Asset("ANIM", "anim/wilson_fx.zip"),
        Asset("ANIM", "anim/player_one_man_band.zip"),
        Asset("ANIM", "anim/player_slurtle_armor.zip"),
        Asset("ANIM", "anim/player_staff.zip"),
        

		Asset("ANIM", "anim/shadow_hands.zip"),

        Asset("SOUND", "sound/sfx.fsb"),
        Asset("SOUND", "sound/wilson.fsb"),
    Asset("ANIM", "anim/willow.zip"),
    Asset("SOUND", "sound/willow.fsb"),
    Asset("ANIM", "anim/wes.zip"),
    Asset("ANIM", "anim/wolfgang.zip"),
    Asset("SOUND", "sound/wolfgang.fsb"),
    Asset("ANIM", "anim/wendy.zip"),
    Asset("SOUND", "sound/wendy.fsb"),
    Asset("ANIM", "anim/wx78.zip"),
    Asset("SOUND", "sound/wx78.fsb"),
    Asset("SOUND", "sound/maxwell.fsb"),
    Asset("ANIM", "anim/waxwell.zip"),
    Asset("SOUND", "sound/wickerbottom.fsb"),
    Asset("ANIM", "anim/wickerbottom.zip"),
    Asset("SOUND", "sound/woodie.fsb"),
    Asset("ANIM", "anim/woodie.zip"),}

local prefabs =
{
"lucy","lighter"
}

local onloadfn = function(inst, data)
	if data and data.sleeping then
		inst.components.sleeper:GoToSleep()
	end
end

local onsavefn = function(inst, data)
	if inst.components.sleeper:IsAsleep() then
		data.sleeping = true
	end
end

local function CalcSanityAura(inst, observer)
	
	if inst.components.follower and inst.components.follower.leader == observer then
		return -TUNING.SANITYAURA_LARGE
	end
	
	return 0
end

local function ontalk(inst, script)
	if GetClock():IsDay() then inst.components.talker:ShutUp() return end
	if not inst:HasTag("cdlfss") then
	inst:AddTag("cdlfss")
	inst.SoundEmitter:PlaySound("dontstarve/characters/"..GetPlayer().prefab.."/talk_LP","darkclone_sound")
	print("dark clone sound")
	inst:DoTaskInTime(1.8, function()
	inst.SoundEmitter:KillSound("darkclone_sound")
	
    inst:RemoveTag("cdlfss")
    end)
	end
end


local function updatedamage(darkclone)
    if GetClock():IsDay() then
			   darkclone.AnimState:SetMultColour(0.1,.1,.1,0.1)
		print("Day b")
		darkclone:RemoveComponent("inspectable")
		darkclone.components.combat:SetDefaultDamage(TUNING.UNARMED_DAMAGE*0.01)
        local brain3 = require "brains/darkclonebrain"
	    darkclone:SetBrain(brain3)
        darkclone:RemoveComponent("thief")


--[[
    elseif GetClock():IsNight() then
        inst.components.combat.defaultdamage = 4*TUNING.ABIGAIL_DAMAGE_PER_SECOND     
    elseif GetClock():IsDusk() then
        inst.components.combat.defaultdamage = 2*TUNING.ABIGAIL_DAMAGE_PER_SECOND --]]
    end

end


local function OnAttacked(inst, data)
local darkclone = inst
    if not GetClock():IsDay() then

    local attacker = data.attacker
	local dmg = data.damage
	if not inst:HasTag("cdlf") and attacker.components.health.currenthealth > 1 then
	if attacker == GetPlayer() then
	attacker.components.health:DoDelta(-dmg/3)
	print(darkclone.components.health.currenthealth)
	else
---	attacker.components.health:DoDelta(-dmg*2)
	end
	print("lifeSteal")
	

	end
	else
	local dpt = GetPlayer():GetPosition()
           darkclone.components.health:DoDelta(-100)
	    darkclone.components.health:SetMaxHealth(TUNING.WILSON_HEALTH*0.01)

	darkclone.Transform:SetPosition(dpt.x +math.random(-6,6), dpt.y, dpt.z+math.random(-6,6))

	end
	inst:AddTag("cdlf")
	inst:DoTaskInTime(3, function() 
    inst:RemoveTag("cdlf")
    end)
end





local function CalcSanityAura_Maxwell(inst, observer)
	return 0
end

local function ShouldAcceptItem(inst, item)
	local currenthealth = inst.components.health.currenthealth / inst.components.health.maxhealth
	if item.components.edible and currenthealth < 1 and item.components.edible.healthvalue > 0 then
		return true
	end
    	if item.components.equippable and (item.components.equippable.equipslot == EQUIPSLOTS.HEAD or item.components.equippable.equipslot == EQUIPSLOTS.HANDS or item.components.equippable.equipslot == EQUIPSLOTS.BODY) and not item.components.projectile then
        	return true
   	end
end

local function OnPickup(inst, item)
    	if item.components.equippable and (item.components.equippable.equipslot == EQUIPSLOTS.HEAD or item.components.equippable.equipslot == EQUIPSLOTS.HANDS or item.components.equippable.equipslot == EQUIPSLOTS.BODY)   then     
		local newslot = item.components.equippable.equipslot
		local current = inst.components.inventory:GetEquippedItem(newslot)
		if current then
            		inst.components.inventory:DropItem(current)
        	end      
        	inst.components.inventory:Equip(item)
	elseif item.components.edible then
                inst.components.health:DoDelta(item.components.edible:GetHealth(inst), nil, item.prefab)
		inst:PushEvent("oneatsomething", {food = item})
		inst.sg:GoToState("eat")
    	end
end

local function OnRefuseItem(inst, item)
    inst.sg:GoToState("refuse")
    local playerprefab = GetPlayer()
    local actualprefab = playerprefab.prefab
    inst.components.talker:Say(GetString(actualprefab, "ACTIONFAIL_GENERIC"))
end

local function NormalRetargetFn(inst)
    return FindEntity(inst, TUNING.PIG_TARGET_DIST,
        function(guy)
                return guy:HasTag("player") and guy.components.health and not guy.components.health:IsDead() and inst.components.combat:CanTarget(guy)
        end)
end


local function OnOpen(inst)
    if not inst.components.health:IsDead() then
        inst.sg:GoToState("open")
    end
end 

local function OnClose(inst) 
    if not inst.components.health:IsDead() then
        inst.sg:GoToState("close")
    end
end 

local slotpos = {}


	for y = 0, 4 do		--5 rows, 3 cols
		--							 ([hor] [loc], [hor width between rows] + [ver] ,0))	
		table.insert(slotpos, Vector3(-25 -150, -y*75 + 185 ,0)) --New column
		table.insert(slotpos, Vector3(-25  -75, -y*75 + 185 ,0)) --original column
		table.insert(slotpos, Vector3(-25     , -y*75 + 185 ,0)) --col at screen edge
	end


local function OnAttackedWendy(inst, data)
end

local function OnAttackedWaxwell(inst, data)
    local attacker = data.attacker
	local dmg = data.damage
	if not inst:HasTag("cdlf") and attacker.components.health.currenthealth > 1 then
	attacker.components.health:DoDelta(-dmg)
	inst.components.health:DoDelta(dmg)
	print("lifeSteal")
	
	inst:AddTag("cdlf")
	inst:DoTaskInTime(0.7, function() 
    inst:RemoveTag("cdlf")
    end)

end
end


local function OnSave(inst, data)
	    inst.components.health:Kill()

end
        
local function OnLoad(inst, data)

	inst:DoTaskInTime(1, function() 
	local darkclone = inst
	local sanity = GetPlayer().components.sanity:GetPercent()
    if darkclone.components.health.currenthealth > 0 and sanity < .4 and (not GetClock():IsDay()) then
	local weapon = GetPlayer().components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
	local armor = GetPlayer().components.inventory:GetEquippedItem(EQUIPSLOTS.BODY)
	local hat = GetPlayer().components.inventory:GetEquippedItem(EQUIPSLOTS.HEAD)
	
	if hat and darkclone.components.inventory:GetEquippedItem(EQUIPSLOTS.HEAD) == nil then
	print(hat.prefab)
		local itemtogive = SpawnPrefab(hat.prefab)
		print("itemz hat")
		darkclone.components.inventory:Equip(itemtogive)
		if itemtogive.components.armor then
			itemtogive.components.armor.condition = 100
		end
	    itemtogive.components.inventoryitem.keepondeath = true
		 itemtogive.persists = false
	end
	if weapon and darkclone.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) == nil then
		print(weapon.prefab)
		local itemtogive = SpawnPrefab(weapon.prefab)
		darkclone.components.inventory:Equip(itemtogive)
		print("itemz HANDS")
		 itemtogive.components.inventoryitem.keepondeath = true
		 itemtogive.persists = false
	end
	if armor and darkclone.components.inventory:GetEquippedItem(EQUIPSLOTS.BODY) == nil and GetPlayer().components.health.currenthealth > 100 then
	
		print(armor.prefab)
		print("itemz BODY")
		local itemtogive = SpawnPrefab(armor.prefab)
	    itemtogive.components.inventoryitem.keepondeath = true
		 itemtogive.persists = false
	    darkclone.components.inventory:Equip(itemtogive)
		if itemtogive.components.armor then
			itemtogive.components.armor.condition = 100
		end
    end
    end

    end)
end






local function fn(Sim)
    
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
	local shadow = inst.entity:AddDynamicShadow()
	
	
	local whoisplayer = GetPlayer()

	
	
	shadow:SetSize( 1.5, .75 )
    inst.Transform:SetFourFaced()
	

	
    inst:AddTag("darkclone")
    inst:AddTag("scarytoprey")

	inst:AddTag("notraptrigger")
    anim:SetBank("wilson")
    ------------------------------------------
	
	MakeCharacterPhysics(inst, 75, .5)
	
    inst:AddComponent("locomotor") -- locomotor must be constructed before the stategraph
    inst.components.locomotor.runspeed = 5.5
    inst.components.locomotor.walkspeed = 4.5
    
    ------------------------------------------
    ------------------------------------------

----    inst:AddComponent("sanityaura")
 -----   inst.components.sanityaura.aurafn = CalcSanityAura

  ---  MakeMediumBurnableCharacter(inst, "pig_torso")
    ------------------
    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(TUNING.WILSON_HEALTH)
	
	
    ------------------
    
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(TUNING.UNARMED_DAMAGE*0.01)
    --inst.components.combat.hiteffectsymbol = "pig_torso"
    inst.components.combat:SetAttackPeriod(2.5)
 --------   inst.components.combat:SetRetargetFunction(3, NormalRetargetFn)
    
    ------------------------------------------
    
    inst:AddComponent("inventory")
    inst.components.inventory.ignorescangoincontainer = true

 	
	
	
	        local lightwatch = inst.entity:AddLightWatcher()
        lightwatch:SetLightThresh(.2)
        lightwatch:SetDarkThresh(.05)

	
	
	
    inst:AddComponent("temperature")
	
	
	
	

    inst:AddComponent("frostybreather")
    inst:AddComponent("darkcloneactionpicker")



    inst:AddComponent("eater")

    ------------------------------------------
    inst.entity:AddLabel()
    inst.Label:SetFontSize(25)
    inst.Label:SetFont(DEFAULTFONT)
    inst.Label:SetPos(0,3,0)
    inst.Label:SetColour(1, 0.75, 0.75)
    inst.Label:Enable(true)
    ------------------------------------------
    inst:AddComponent("follower")
    inst.components.follower.maxfollowtime = 99999999
    --print("treeguard should follow "..whoisplayer)
    whoisplayer.components.leader:AddFollower(inst)
    inst.components.follower:AddLoyaltyTime(9999999)
    ------------------------------------------]]
    ------------------------------------------
    ------------------------------------------
   
    inst:SetBrain(brain)

 local doer = GetPlayer()

	inst:AddTag("shadow")

	
    inst:AddComponent("lootdropper")
    inst:AddComponent("talker")

    inst.AnimState:Hide("ARM_carry") 
    inst.AnimState:Show("ARM_normal") 

----    inst:AddComponent("wisecrackerclone")
    inst:AddComponent("inspectable")

    -- begin custom functions
	anim:SetBuild("wilson")
    anim:SetBank("wilson")
    local darkclonebuild = GetPlayer()
    anim:SetBuild(darkclonebuild.prefab)
	
    if darkclonebuild.prefab == "wilson" then
	    	inst:AddComponent("beard")
    		inst.components.beard.onreset = function()
        		inst.AnimState:ClearOverrideSymbol("beard")
		end
		inst.components.beard.prize = "beardhair"

		local beard_days = {4, 8, 16}

		if GetPlayer().components.beard and GetPlayer().components.beard.daysgrowth then
			local daysgrowth = GetPlayer().components.beard.daysgrowth
			if daysgrowth > beard_days[3] then
		        inst.AnimState:OverrideSymbol("beard", "beard", "beard_long")	
			elseif daysgrowth > beard_days[2] then
				inst.AnimState:OverrideSymbol("beard", "beard", "beard_medium")
			elseif daysgrowth > beard_days[1] then
				inst.AnimState:OverrideSymbol("beard", "beard", "beard_short")
			else
			end
		end
    elseif darkclonebuild.prefab == "willow" then
		inst.components.health.fire_damage_scale = 0
	elseif darkclonebuild.prefab == "wolfgang" then
		inst.components.health:SetMaxHealth(TUNING.WILSON_HEALTH * 1.5 )
		inst.components.combat.damagemultiplier = 1.5
    elseif darkclonebuild.prefab == "wx78" then
		inst.components.eater.ignoresspoilage = true
    end
	
	
	
		local darkclone =  inst

    inst:DoPeriodicTask(math.random(30,45), function()
	
		if not GetClock():IsDay() then
        local words = {"Hey!","Something goes on...","Return my stuff!","Make a fire please.",
		"Do you live here?","Stay away!","Where is my chester?","I am afraid of you...","Give me torch.",
		"Hello","You are mean.","Please, leave me alone.","Hey! This is my clothes!","Are you real?","It's too dark here...",
		"It is so dark here.","Get over here!","You can run, but you cann't hide!","Death comes, you have to follow.",
		"May be a duel?","I will send you to the other side!","Come with me.","Uh... leave me, please...","Rain-rain, go away...",
		"Spiders... Spiders! Spiders everythere!","Is this my fate?","Did you hear that?","Carry on...","Silence...","No last wishes, no second thoughts.",
		"The strong shall eat the weak.","I'm warning you.","Your death presaged.","Let me tell your fate.","I know just the place for you.",
		"I just want to stay here...", "You are all alone!", "Death claims all."}
        local word = words[math.random(#words)]
        inst.components.talker:Say(word, 4, false)
		end
    end)
	
	
    inst:DoPeriodicTask(7, function()
	 inst.components.combat:SetAttackPeriod(math.random(1,3))

	
	local sanity = GetPlayer().components.sanity:GetPercent()
    if darkclone.components.health.currenthealth > 0 and sanity < .4 and (not GetClock():IsDay()) then
	local weapon = GetPlayer().components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
	local armor = GetPlayer().components.inventory:GetEquippedItem(EQUIPSLOTS.BODY)
	local hat = GetPlayer().components.inventory:GetEquippedItem(EQUIPSLOTS.HEAD)
	
	if hat and darkclone.components.inventory:GetEquippedItem(EQUIPSLOTS.HEAD) == nil then
		local itemtogive = SpawnPrefab(hat.prefab)
		print("itemz hat")
		darkclone.components.inventory:Equip(itemtogive)
		if itemtogive.components.armor then
			itemtogive.components.armor.condition = 100
		end
	    itemtogive.components.inventoryitem.keepondeath = true
		 itemtogive.persists = false
	end
	if weapon and darkclone.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) == nil then
		print(weapon.prefab)
		local itemtogive = SpawnPrefab(weapon.prefab)
		darkclone.components.inventory:Equip(itemtogive)
		print("itemz HANDS")
		 itemtogive.components.inventoryitem.keepondeath = true
		 itemtogive.persists = false
	end
	if armor and darkclone.components.inventory:GetEquippedItem(EQUIPSLOTS.BODY) == nil and GetPlayer().components.health.currenthealth > 100 then
	
		print(armor.prefab)
		print("itemz BODY")
		local itemtogive = SpawnPrefab(armor.prefab)
	    itemtogive.components.inventoryitem.keepondeath = true
	    darkclone.components.inventory:Equip(itemtogive)
		 itemtogive.persists = false
		if itemtogive.components.armor then
			itemtogive.components.armor.condition = 100
		end
    end
    end
	end)	
	
	
	
	-------UPDATE GetPlayer()

    inst:DoPeriodicTask(10, function()
	
	local sanity = GetPlayer().components.sanity:GetPercent()
	---- BEHAIVOUR
	

	if darkclone and darkclone.components.health.currenthealth > 0 then
         local dist = GetPlayer():GetDistanceSqToInst(darkclone)
			
         if dist>40*40 and not GetPlayer():HasTag("aquatic") then
	            print("teleport!!!")
	            local dpt = GetPlayer():GetPosition()
	            darkclone.Transform:SetPosition(dpt.x +math.random(-5,5), dpt.y, dpt.z+math.random(-5,5))
         end
	
	if sanity > .56 then
         --+++ if darkclone:HasTag("hasp1itemz") then
	   darkclone.components.combat:GiveUp()
	     --    darkclone.components.inventory.dropondeath = false
           darkclone.components.health:DoDelta(-75)
        ---	end
	return
    end
	
	
	if darkclone and darkclone.components.health.currenthealth > 0 then
	local colour = 1-(sanity*2)

	if not GetClock():IsDay() then
	   darkclone:RemoveTag("NOCLICK")
	   darkclone.AnimState:SetMultColour(colour,colour,colour,colour*2)
	   shadow:SetSize( 1.5, .75 )
	else
	   shadow:SetSize( 0, 0 )
	   darkclone:AddTag("shadow")
	   darkclone:AddTag("NOCLICK")
	   darkclone.components.combat:GiveUp()
	   darkclone.AnimState:SetMultColour(0.1,.1,.1,0.1)
    end
	
	if (sanity < .55 and sanity > .4) or GetClock():IsDay() then
	    darkclone:AddTag("shadow")
	    darkclone.components.health:SetMaxHealth(TUNING.WILSON_HEALTH/2)
        darkclone.components.health:DoDelta(100)
      -- 	print("Normal b")
			   darkclone.components.combat:GiveUp()
        darkclone.components.combat.damagemultiplier = 0.01
		darkclone:RemoveComponent("inspectable")
		darkclone.components.combat:SetDefaultDamage(TUNING.UNARMED_DAMAGE*0.01)
        local brain = require "brains/darkclonebrain"
	    darkclone:SetBrain(brain)
        darkclone:RemoveComponent("thief")
	elseif sanity >.25 and sanity < .4 then
	    darkclone:AddTag("shadow")
	   darkclone.components.combat:GiveUp()
		if darkclone then
		darkclone:AddComponent("inspectable")
	    darkclone:RemoveTag("hasp1itemz")
	    darkclone.components.combat:SetDefaultDamage(TUNING.UNARMED_DAMAGE*0.01)
        darkclone.components.combat.damagemultiplier = 0.01
	-- 	print("STEAL b")
        darkclone:AddComponent("thief")
        local brain = require "brains/darkclonestealbrain"
        darkclone:SetBrain(brain)
		end
		
    elseif darkclone.components.health.currenthealth > 0 and sanity < .25 and (not GetClock():IsDay()) then
	    darkclone:RemoveTag("NOCLICK")
	    darkclone:RemoveTag("shadow")
		--print("attack b")
		if not darkclone.components.health.maxhealth == TUNING.WILSON_HEALTH*0.7 then
	    darkclone.components.health:SetMaxHealth(TUNING.WILSON_HEALTH*0.7)
		end
        darkclone.components.combat.damagemultiplier = 0.6
	    darkclone.components.combat:SetDefaultDamage(TUNING.UNARMED_DAMAGE*0.25)
		local brain2 = require "brains/darkclonebrain"
	    darkclone:SetBrain(brain2)
        darkclone.components.combat:SetTarget(GetPlayer())
		darkclone:AddComponent("inspectable")
        darkclone:AddTag("hasp1itemz")
		

	
	
	end
end
end

	
	
   end)	
    inst.components.talker.ontalk = ontalk

	local function onkilledbyother(inst, attacker)
		if attacker and attacker.components.sanity then
			attacker.components.sanity:DoDelta(TUNING.SANITY_LARGE)
			SpawnPrefab("nightmarefuel").Transform:SetPosition(inst:GetPosition():Get())
			SpawnPrefab("nightmarefuel").Transform:SetPosition(inst:GetPosition():Get())
			SpawnPrefab("nightmarefuel").Transform:SetPosition(inst:GetPosition():Get())
			
			if attacker.components.galunmonsterspawner then
				attacker.components.galunmonsterspawner.darkclone_timeout = TUNING.DARKCLONE_TIMEOUT*0.75 + TUNING.DARKCLONE_TIMEOUT*math.random()*0.5
			end
		end
	end
	
	inst.components.combat.onkilledbyother = onkilledbyother

	
	----------update end
	
    inst:ListenForEvent("attacked", OnAttacked)
    inst:ListenForEvent( "dusktime", function() updatedamage(inst) end , GetWorld())
    inst:ListenForEvent( "daytime", function() updatedamage(inst) end , GetWorld())
    inst:ListenForEvent( "nighttime", function() updatedamage(inst) end , GetWorld())
    updatedamage(inst)

    inst.OnSave = OnSave
    inst.OnLoad = OnLoad


	inst:SetStateGraph("SGdarkclone")

    return inst
end

return Prefab( "common/darkclone", fn, assets, prefabs)
