local assets=
{
	Asset("ANIM", "anim/staffs.zip"),
	Asset("ANIM", "anim/swap_staffs.zip"), 
	Asset("ATLAS", "images/inventoryimages/galunsword.xml"),

	
    
}




local prefabs =
{
    "ice_projectile",
    "fire_projectile",
    "staffcastfx",
	"stafflight",
	"galunswordfire",
}    



local function onfinished(inst)
    inst:Remove()
end

local function onequip(inst, owner)
   --- owner.AnimState:OverrideSymbol("swap_object", "gold_spear", "swap_spear")
    owner.AnimState:OverrideSymbol("swap_object", "swap_staffs", "purplestaff")

  ----  owner.AnimState:OverrideSymbol("swap_object", "swap_nightmaresword", "swap_nightmaresword")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
    inst.fire = SpawnPrefab( "galunswordfire" )
    local follower = inst.fire.entity:AddFollower()
    follower:FollowSymbol( owner.GUID, "swap_object", 0, -110, 1 )
 end

local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
	
	inst.fire:Remove()
    inst.fire = nil
    
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal")
    inst.SoundEmitter:KillSound("torch")
end




local function onattack(inst, owner, target)
if owner.components.sanity and owner:HasTag("player") then
    if not (target:HasTag("wall") or target:HasTag("shadowcreature") or target:HasTag("sword_attacker")) then
		print("calling galun!!!")
		GetPlayer().components.sanitymonsterspawner:GalunMobAttacker(1,inst,math.floor(math.random(0,2)),target)
    else
		owner.components.sanity:DoDelta(-0.5)
	end
	if target:HasTag("sword_attacker") then
		owner.components.sanity:DoDelta(3)
		target:Remove()
	end
end
end





local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()
	
    MakeInventoryPhysics(inst)
    
  ---  inst.AnimState:SetBank("nightmaresword")
    --inst.AnimState:SetBuild("nightmaresword")
  ---  inst.AnimState:PlayAnimation("idle")
    anim:SetBank("staffs")
    anim:SetBuild("staffs")
    anim:PlayAnimation("colourpurple")
  
    inst.AnimState:SetMultColour(.8, .4, .4, 0.5)
    
    inst:AddTag("shadow")
    inst:AddTag("sharp")
    
    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(TUNING.NIGHTSWORD_DAMAGE/3)
    inst.components.weapon.onattack = onattack
    -------
    
    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(TUNING.NIGHTSWORD_USES*1.5)
    inst.components.finiteuses:SetUses(TUNING.NIGHTSWORD_USES*1.5)
    
    inst.components.finiteuses:SetOnFinished( onfinished )

    inst:AddComponent("inspectable")
	
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/galunsword.xml"

    inst:AddComponent("dapperness")
    inst.components.dapperness.dapperness = TUNING.CRAZINESS_MED,
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
    
    return inst
end

return Prefab( "common/inventory/galunsword", fn, assets) 
