local brain = require "brains/s_charbrain"

local assets =
{
	Asset("ANIM", "anim/player_basic.zip"),
        Asset("ANIM", "anim/player_idles_shiver.zip"),
        Asset("ANIM", "anim/player_actions.zip"),
        Asset("ANIM", "anim/player_actions_axe.zip"),
        Asset("ANIM", "anim/player_actions_pickaxe.zip"),
        Asset("ANIM", "anim/player_actions_shovel.zip"),
        Asset("ANIM", "anim/player_actions_blowdart.zip"),
        Asset("ANIM", "anim/player_actions_eat.zip"),
        Asset("ANIM", "anim/player_actions_item.zip"),
        Asset("ANIM", "anim/player_cave_enter.zip"),
        Asset("ANIM", "anim/player_actions_uniqueitem.zip"),
        Asset("ANIM", "anim/player_actions_bugnet.zip"),
        Asset("ANIM", "anim/player_actions_fishing.zip"),
        Asset("ANIM", "anim/player_actions_boomerang.zip"),
        Asset("ANIM", "anim/player_bush_hat.zip"),
        Asset("ANIM", "anim/player_attacks.zip"),
        Asset("ANIM", "anim/player_idles.zip"),
        Asset("ANIM", "anim/player_rebirth.zip"),
        Asset("ANIM", "anim/player_jump.zip"),
        Asset("ANIM", "anim/player_amulet_resurrect.zip"),
		Asset("ANIM", "anim/player_teleport.zip"),
        Asset("ANIM", "anim/wilson_fx.zip"),
        Asset("ANIM", "anim/player_one_man_band.zip"),
        Asset("ANIM", "anim/player_slurtle_armor.zip"),
        Asset("ANIM", "anim/player_staff.zip"),
	Asset("ANIM", "anim/wilton.zip"),
        

		Asset("ANIM", "anim/shadow_hands.zip"),

        Asset("SOUND", "sound/sfx.fsb"),
        Asset("SOUND", "sound/wilson.fsb"),
}

local prefabs =
{

}

local function CalcSanityAura(inst, observer)
	
	if inst.components.follower and inst.components.follower.leader == observer then
		return -TUNING.SANITYAURA_SMALL
	end
	
	return 0
end


local function ShouldAcceptItem(inst, item)
	local currenthealth = inst.components.health.currenthealth / inst.components.health.maxhealth
    	if item.components.equippable and (item.components.equippable.equipslot == EQUIPSLOTS.HEAD or item.components.equippable.equipslot == EQUIPSLOTS.BODY) and not item.components.projectile then
		if item.prefab == "axe" then
			return false
		end
        	return true
   	end
end

local function OnGetItemFromPlayer(inst, giver, item)
    	if item.components.equippable and (item.components.equippable.equipslot == EQUIPSLOTS.HEAD or item.components.equippable.equipslot == EQUIPSLOTS.HANDS or item.components.equippable.equipslot == EQUIPSLOTS.BODY)   then     
		local newslot = item.components.equippable.equipslot
		local current = inst.components.inventory:GetEquippedItem(newslot)
		if current then
            		inst.components.inventory:DropItem(current)
        	end      
        	inst.components.inventory:Equip(item)
    	end
end

local function OnRefuseItem(inst, item)
    inst.sg:GoToState("refuse")
    local playerprefab = GetPlayer()
    local actualprefab = playerprefab.prefab
    inst.components.talker:Say(GetString(actualprefab, "ACTIONFAIL_GENERIC"))
end

local function NormalRetargetFn(inst)
    return FindEntity(inst, TUNING.PIG_TARGET_DIST,
        function(guy)
                return guy:HasTag("monster") and guy.prefab ~= "webber" and guy.components.health and not guy.components.health:IsDead() and inst.components.combat:CanTarget(guy)
        end)
end






















local BigPopupDialogScreen = require "screens/bigpopupdialog"

local function dialog(inst,charname,text,leftbut,rightbut)

	SetPause(true)
	
	local name = charname or "Stranger"
	
	local function leftbut()
		TheFrontEnd:PopScreen()
		SetPause(false)
		inst.components.activatable.inactive = true
		
		
	dialog(inst,"Willow","Willow: Uh, hi! My name is Willow, I stuck here... But the worst thing what I lost my lighter... Help me find it.","Repeat...","Lets go!")	
	end

	local function rightbut()
		TheFrontEnd:PopScreen()
		SetPause(false) 
		inst.components.activatable.inactive = true
	end
	
	local lb = leftbut
	local rb = rightbut
	local bodytext = text
	-- A/B test
	if bodytext == nil then
	bodytext = "-Strange gurl turns to you-"
	lb = "Who are you?"
	rb = "You are not real!"
	end
	
	TheFrontEnd:PushScreen(BigPopupDialogScreen(name, bodytext,
			{{text=lb, cb = leftbut},
			 {text=rb, cb = rightbut}  }))	
	
end



local function OnActivate(inst)
	--do popup confirmation
	--do portal presentation 
	--save and do restart
    ProfileStatsSet("portal_used", true)
	SetPause(true,"portal")
	
	local function startadventure()
		TheFrontEnd:PopScreen()
		SetPause(false)
		OnActivate(inst)
		inst.components.activatable.inactive = true
	end

	local function rejectadventure()
		TheFrontEnd:PopScreen()
		SetPause(false) 
		inst.components.activatable.inactive = true
	end

	-- A/B test
	local bodytext = GetTestGroup() == 0 and STRINGS.S_CHAR_TALK_HELLO[inst.scriptnumber]

	TheFrontEnd:PushScreen(BigPopupDialogScreen(STRINGS.UI.STARTADVENTURE.TITLE, bodytext,
			{{text=STRINGS.S_CHAR_TALK_HELLO_A[1], cb = startadventure},
			 {text=STRINGS.UI.STARTADVENTURE.NO, cb = rejectadventure}  }))
end



local function GetVerb(inst)
	return "Talk"
end














local function fn(Sim)
    
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
	local shadow = inst.entity:AddDynamicShadow()
	local whoisplayer = GetPlayer()
	

	shadow:SetSize( 1.5, .75 )
    inst.Transform:SetFourFaced()
	
    MakeCharacterPhysics(inst, 30, .3)

    inst:AddTag("s_char")
    inst:AddTag("sheltercarrier")
    inst:AddTag("scarytoprey")

    anim:SetBank("wilson")
    anim:SetBuild("willow")
    
    ------------------------------------------

    inst:AddComponent("locomotor") -- locomotor must be constructed before the stategraph
    inst.components.locomotor.runspeed = 7
    inst.components.locomotor.walkspeed = 7
    
    ------------------------------------------


    inst:AddComponent("sanityaura")
    inst.components.sanityaura.aurafn = CalcSanityAura
    ------------------
    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(150)

    ------------------
    
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(TUNING.UNARMED_DAMAGE)
    --inst.components.combat.hiteffectsymbol = "pig_torso"
    inst.components.combat:SetAttackPeriod(2)
    inst.components.combat:SetRetargetFunction(3, NormalRetargetFn)
    
    ------------------------------------------
    
    inst:AddComponent("inventory")

    ------------------------------------------
    inst.entity:AddLabel()
    inst.Label:SetFontSize(20)
    inst.Label:SetFont(DEFAULTFONT)
    inst.Label:SetPos(0,3,0)
    inst.Label:SetColour(1, 1, 1)
    inst.Label:Enable(true)
    ------------------------------------------

    inst:AddComponent("follower")
    inst.components.follower.maxfollowtime = 99999999
    whoisplayer.components.leader:AddFollower(inst)
    inst.components.follower:AddLoyaltyTime(9999999)
    ------------------------------------------
    inst:AddComponent("talker")
    inst.components.talker:StopIgnoringAll()
    ------------------------------------------
    inst:AddComponent("inspectable")
    ---local minimap = inst.entity:AddMiniMapEntity()
	---minimap:SetIcon( "summonskeleton.tex" )
    ------------------------------------------
   
    inst:SetBrain(brain)

    inst:AddComponent("lootdropper")

    inst:AddComponent("trader")
    inst.components.trader:SetAcceptTest(ShouldAcceptItem)
    inst.components.trader.onaccept = OnGetItemFromPlayer
    inst.components.trader.onrefuse = OnRefuseItem

    inst.AnimState:Hide("ARM_carry") 
    inst.AnimState:Show("ARM_normal") 

    inst:AddComponent("temperature")
	
	
	
	inst:AddComponent("named")
    inst.components.named:SetName("Willow")
	inst.scriptnumber = 2

    inst:AddComponent("frostybreather")
    inst:AddComponent("darkcloneactionpicker")

 
	inst:AddComponent("activatable")
    inst.components.activatable.OnActivate = OnActivate
    inst.components.activatable.inactive = true
    inst.components.activatable.getverb = GetVerb
	inst.components.activatable.quickaction = true



    inst:SetStateGraph("SGdarkclone")
   
    return inst
end

return Prefab( "common/s_char", fn, assets, prefabs)
