
local assets=
{
	Asset("ANIM", "anim/stinkray.zip"),
	Asset("SOUND", "sound/bat.fsb"),
	Asset("MINIMAP_IMAGE", "stinkray"),
}

local prefabs =
{
	"venomgland",
	"poisonbubble_short",
	"monstermeat",
	"splash_water",
}

local SLEEP_DIST_FROMHOME = 1
local SLEEP_DIST_FROMTHREAT = 20
local MAX_CHASEAWAY_DIST = 80
local MAX_TARGET_SHARES = 5
local SHARE_TARGET_DIST = 30


local function KeepThreat(inst, threat)
	return threat:GetIsOnWater(threat:GetPosition():Get()) -- and not (threat.components.poisonable and threat.components.poisonable:IsPoisoned())
end

local function MakeTeam(inst, attacker)

end

local function Retarget(inst)

end

local function KeepTarget(inst, target)
	if not target:GetIsOnWater(target:GetPosition():Get()) then return false end
	-- if target.components.poisonable and target.components.poisonable:IsPoisoned() then return false end

		return true

end

local function OnAttacked(inst, data)

end

local function OnCombatTarget(inst, data)
	--If you're in a team or have a combat target then run.
	if data and data.target then
		inst.components.locomotor:SetShouldRun(true)
	else
		inst.components.locomotor:SetShouldRun(false)
	end
end

local function OnHitOther(inst, other, damage, stimuli)

end

local function SetLocoState(inst, state)
	--"gotofly" or "gotoswim"
	inst.LocoState = string.lower(state)
end

local function IsLocoState(inst, state)
	return inst.LocoState == string.lower(state)
end

local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
	local shadow = inst.entity:AddDynamicShadow()
	shadow:SetSize( 1.75, .6 )
	shadow:Enable(false)

	inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
	inst.Transform:SetNoFaced()

	inst.scale_flying = TUNING.STINKRAY_SCALE_FLYING
	inst.scale_water = TUNING.STINKRAY_SCALE_WATER
	inst.Transform:SetScale(inst.scale_water, inst.scale_water, inst.scale_water)

	MakeGhostPhysics(inst, 1, .5)

	anim:SetBank("stinkray")
	anim:SetBuild("stinkray")

	inst:AddComponent("locomotor")
	inst.components.locomotor:SetSlowMultiplier( 1 )
	inst.components.locomotor:SetTriggersCreep(false)
	inst.components.locomotor.pathcaps = { ignorecreep = true }
	inst.components.locomotor.walkspeed = TUNING.STINKRAY_WALK_SPEED


	inst:AddTag("aquatic")
	inst:AddTag("monster")
	inst:AddTag("hostile")
	inst:AddTag("stungray")
	inst:AddTag("scarytoprey")
	inst:AddTag("flying")

	inst:AddComponent("eater")
	inst.components.eater:SetCarnivore()
	inst.components.eater.strongstomach = true

	inst:AddComponent("sleeper")
	inst.components.sleeper:SetResistance(2)
	inst.components.sleeper:SetNocturnal(true)
	inst.components.sleeper.onlysleepsfromitems = true 


	inst:AddComponent("combat")
	inst.components.combat.hiteffectsymbol = "bat_body"
	inst.components.combat:SetAttackPeriod(TUNING.STINKRAY_ATTACK_PERIOD)
	inst.components.combat:SetRange(TUNING.STINKRAY_ATTACK_DIST)
	inst.components.combat:SetRetargetFunction(3, Retarget)
	inst.components.combat:SetKeepTargetFunction(KeepTarget)
	inst.components.combat:SetOnHitOther(OnHitOther)
	inst.components.combat:SetDefaultDamage(0)


	inst:AddComponent("health")
	inst.components.health:SetMaxHealth(TUNING.STINKRAY_HEALTH)

	inst:AddComponent("lootdropper")
	inst.components.lootdropper:AddRandomLoot("venomgland", 1)   
	inst.components.lootdropper:AddRandomLoot("monstermeat", 2)
	inst.components.lootdropper.numrandomloot = 1

	inst:AddComponent("inventory")

    inst:AddComponent("inspectable")
    inst.components.inspectable.nameoverride = "stungray"
	
	inst:AddComponent("knownlocations")

	inst:DoTaskInTime(1*FRAMES, function() inst.components.knownlocations:RememberLocation("home", Vector3(inst.Transform:GetWorldPosition()), true) end)

	MakeMediumBurnableCharacter(inst, "ray_face")
	MakeMediumFreezableCharacter(inst, "ray_face")

	inst:AddComponent("teamattacker")
	inst.components.teamattacker.team_type = "stungray"
	inst.components.teamattacker.run = true
	
	inst:ListenForEvent("attacked", OnAttacked)
	inst:ListenForEvent("newcombattarget", OnCombatTarget)
	inst:ListenForEvent("losttarget", OnCombatTarget)

	SetLocoState(inst, "swim")
	inst.SetLocoState = SetLocoState
	inst.IsLocoState = IsLocoState

	inst:SetStateGraph("SGStungray")
	local brain = require "brains/stungraybrain"
	inst:SetBrain(brain)

	return inst
end

--if GetPlayer().components.driver then
return Prefab("forest/monsters/stungray_galun", fn, assets, prefabs)
--end